/* 
   This file was automatically generated on February 23, 2015 23:29:10
   by GpoSolver, (c) 2013--2014, Jan Heller, hellej1@cmp.felk.cvut.cz,
   Czech Technical University, Prague, Czech Republic 

   This solver takes:
      24 residual parameters: [ra1, ra4, ra7, ra2, ra5, ra8, ra3, ra6, ra9, ta1, ta2, ta3, rb1, rb4, rb7, rb2, rb5, rb8, rb3, rb6, rb9, tb1, tb2, tb3]
       1 problem parameters : [n]
*/

#include "hec_problem.h"

using namespace GpoSolver;
using namespace Eigen;


void HecProblem::updateAuxiliaries(const double *pars, double *aux) const {
  double t0 = pars[0];
  aux[0] = t0;
}

double HecProblem::evalPolyObjective(const double *rpars, const double *ppars, const double *vars) const {
  double t2 = vars[0]*vars[0];
  double t3 = vars[1]*vars[1];
  double t4 = vars[2]*vars[2];
  double t5 = vars[3]*vars[3];
  double t6 = t2+t3-t4-t5;
  double t7 = vars[0]*vars[3]*2.0;
  double t8 = vars[1]*vars[2]*2.0;
  double t9 = vars[0]*vars[2]*2.0;
  double t11 = t7+t8;
  double t12 = vars[1]*vars[3]*2.0;
  double t19 = t7-t8;
  double t21 = t9+t12;
  double t10 = rpars[0]*t6+rpars[3]*t11-rpars[12]*t6+rpars[13]*t19-rpars[14]*t21-rpars[6]*(t9-vars[1]*vars[3]*2.0);
  double t14 = t9-t12;
  double t15 = vars[0]*vars[1]*2.0;
  double t16 = vars[2]*vars[3]*2.0;
  double t18 = t2-t3+t4-t5;
  double t23 = t15-t16;
  double t13 = rpars[1]*t6+rpars[4]*t11-rpars[7]*t14-rpars[12]*t11-rpars[13]*t18+rpars[14]*t23;
  double t20 = t15+t16;
  double t25 = t2-t3-t4+t5;
  double t17 = -rpars[2]*t6-rpars[5]*t11+rpars[8]*t14-rpars[12]*t14+rpars[13]*t20+rpars[14]*t25;
  double t22 = rpars[0]*t19-rpars[3]*t18+rpars[15]*t6-rpars[6]*t20-rpars[16]*t19+rpars[17]*t21;
  double t24 = rpars[1]*t19-rpars[4]*t18+rpars[15]*t11-rpars[7]*t20+rpars[16]*t18-rpars[17]*t23;
  double t26 = rpars[2]*t19-rpars[5]*t18-rpars[8]*t20-rpars[15]*t14+rpars[16]*t20+rpars[17]*t25;
  double t27 = rpars[0]*t21-rpars[18]*t6-rpars[3]*t23+rpars[6]*t25+rpars[19]*t19-rpars[20]*t21;
  double t28 = rpars[1]*t21-rpars[4]*t23-rpars[18]*t11+rpars[7]*t25-rpars[19]*t18+rpars[20]*t23;
  double t29 = rpars[2]*t21-rpars[5]*t23+rpars[18]*t14+rpars[8]*t25-rpars[19]*t20-rpars[20]*t25;
  double t30 = rpars[9]-vars[4]-rpars[21]*t6+rpars[22]*t19-rpars[23]*t21+rpars[0]*vars[4]+rpars[3]*vars[5]+rpars[6]*vars[6];
  double t31 = rpars[10]-vars[5]-rpars[21]*t11-rpars[22]*t18+rpars[23]*t23+rpars[1]*vars[4]+rpars[4]*vars[5]+rpars[7]*vars[6];
  double t32 = rpars[11]-vars[6]+rpars[21]*t14-rpars[22]*t20-rpars[23]*t25+rpars[2]*vars[4]+rpars[5]*vars[5]+rpars[8]*vars[6];
  double t0 = t10*t10+t13*t13+t17*t17+t22*t22+t24*t24+t26*t26+t27*t27+t28*t28+t29*t29+t30*t30+t31*t31+t32*t32;

  return t0;
}

void HecProblem::evalPolyConstraints(const double *vars, const double *pars, double *cons) const {

  double aux[2];

  updateAuxiliaries(pars, aux);

  double t2 = vars[0]*vars[0];
  double t3 = vars[1]*vars[1];
  double t4 = vars[2]*vars[2];
  double t5 = vars[3]*vars[3];
  cons[0] = t2+t3+t4+t5-1.0;
  cons[1] = -t2-t3-t4-t5+1.0;
  cons[2] = vars[0];
  cons[3] = aux[0]-vars[4]*vars[4]-vars[5]*vars[5]-vars[6]*vars[6];
}

void HecProblem::evalSdpObjectiveVariables(const double *rpars, const double *ppars, double **vars) const {
  double t2 = rpars[9]*rpars[22]*4.0;
  double t3 = rpars[11]*rpars[21]*4.0;
  double t4 = rpars[10]*rpars[22]*2.0;
  double t5 = rpars[11]*rpars[23]*2.0;
  double t6 = rpars[10]*rpars[23]*4.0;
  double t7 = rpars[9]*rpars[21]*2.0;
  double t8 = rpars[0]-1.0;
  double t9 = rpars[4]-1.0;
  double t10 = rpars[8]-1.0;
  double t11 = rpars[22]*t8*4.0;
  double t12 = rpars[3]*rpars[22]*4.0;
  double t13 = rpars[6]*rpars[22]*4.0;
  double t14 = rpars[2]*rpars[21]*4.0;
  double t15 = rpars[5]*rpars[21]*4.0;
  double t16 = rpars[21]*t10*4.0;
  double t17 = rpars[1]*rpars[22]*2.0;
  double t18 = rpars[2]*rpars[23]*2.0;
  double t19 = rpars[5]*rpars[23]*2.0;
  double t20 = rpars[22]*t9*2.0;
  double t21 = rpars[7]*rpars[22]*2.0;
  double t22 = rpars[23]*t10*2.0;
  double t23 = rpars[1]*rpars[23]*4.0;
  double t24 = rpars[23]*t9*4.0;
  double t25 = rpars[7]*rpars[23]*4.0;
  double t26 = rpars[21]*t8*2.0;
  double t27 = rpars[3]*rpars[21]*2.0;
  double t28 = rpars[6]*rpars[21]*2.0;
  double t29 = rpars[0]-rpars[12];
  double t30 = rpars[1]-rpars[13];
  double t31 = rpars[2]-rpars[14];
  double t32 = rpars[3]-rpars[15];
  double t33 = rpars[4]-rpars[16];
  double t34 = rpars[5]-rpars[17];
  double t35 = rpars[6]-rpars[18];
  double t36 = rpars[7]-rpars[19];
  double t37 = rpars[8]-rpars[20];
  double t38 = rpars[8]*2.0;
  double t39 = rpars[4]*2.0;
  double t40 = rpars[12]*2.0;
  double t41 = rpars[0]*2.0;
  double t42 = rpars[16]*2.0;
  double t43 = t29*t29;
  double t44 = t33*t33;
  double t45 = t34*t34;
  double t46 = t36*t36;
  double t47 = t37*t37;
  double t48 = rpars[20]*2.0;
  double t49 = t39-t48;
  double t50 = rpars[5]*2.0;
  double t51 = rpars[19]*2.0;
  double t52 = t50+t51;
  double t53 = rpars[7]*2.0;
  double t54 = rpars[17]*2.0;
  double t55 = t53+t54;
  double t56 = t38-t42;
  double t57 = rpars[3]*rpars[3];
  double t58 = rpars[6]*rpars[6];
  double t59 = rpars[21]*rpars[21];
  double t60 = rpars[22]*rpars[22];
  double t61 = rpars[23]*rpars[23];
  double t62 = rpars[3]*2.0;
  double t63 = rpars[13]*2.0;
  double t64 = t39-t40;
  double t65 = t30*t64*2.0;
  double t66 = t41-t42;
  double t67 = rpars[1]*2.0;
  double t68 = rpars[15]*2.0;
  double t69 = rpars[2]*2.0;
  double t70 = rpars[18]*2.0;
  double t71 = t69+t70;
  double t72 = rpars[5]*t31*4.0;
  double t73 = rpars[19]*t35*4.0;
  double t74 = t41-t48;
  double t75 = t38-t40;
  double t76 = rpars[6]*2.0;
  double t77 = rpars[14]*2.0;
  double t78 = t35*t74*2.0;
  double t79 = t67+t68;
  double t80 = rpars[1]*t36*4.0;
  double t81 = rpars[15]*t34*4.0;
  double t82 = t43*2.0;
  double t83 = t31*t31;
  double t84 = t35*t35;
  double t85 = rpars[1]+rpars[13];
  double t86 = t30*t85*2.0;
  double t87 = rpars[3]+rpars[15];
  double t88 = t76+t77;
  double t89 = rpars[1]*rpars[1];
  double t90 = rpars[7]*rpars[7];
  double t91 = t59*2.0;
  double t92 = t60*2.0;
  double t93 = t61*2.0;
  double t94 = t34*t56*2.0;
  double t95 = t62+t63;
  double t96 = rpars[6]*t32*4.0;
  double t97 = rpars[14]*t30*4.0;
  double t98 = t30*t30;
  double t99 = t32*t32;
  double t100 = t44*2.0;
  double t101 = rpars[2]+rpars[14];
  double t102 = t31*t101*2.0;
  double t103 = rpars[5]+rpars[17];
  double t104 = t34*t103*2.0;
  double t105 = rpars[6]+rpars[18];
  double t106 = rpars[7]+rpars[19];
  double t107 = rpars[2]*rpars[2];
  double t108 = rpars[5]*rpars[5];
  double t109 = t33*t55*2.0;
  double t110 = t36*t49*2.0;
  double t111 = t37*t71*2.0;
  double t112 = t67-t68;
  double t113 = rpars[14]*t64*4.0;
  double t114 = rpars[18]*t49*4.0;
  double t115 = t29*t95*2.0;
  double t116 = t69-t70;
  double t117 = rpars[2]*t34*4.0;
  double t118 = rpars[13]*t75*4.0;
  double t119 = rpars[15]*t56*4.0;
  double t120 = t37*t52*2.0;
  double t121 = rpars[14]*t85*4.0;
  double t122 = t62-t63;
  double t123 = rpars[3]*t35*4.0;
  double t124 = rpars[17]*t66*4.0;
  double t125 = rpars[19]*t74*4.0;
  double t126 = t66*t66;
  double t127 = t64*t64;
  double t128 = t74*t74;
  double t129 = t75*t75;
  double t130 = t49*t49;
  double t131 = t56*t56;
  double t132 = t76-t77;
  double t133 = t50-t51;
  double t134 = t53-t54;
  double t135 = rpars[13]*rpars[13];
  double t136 = rpars[14]*rpars[14];
  double t137 = rpars[15]*rpars[15];
  double t138 = rpars[17]*rpars[17];
  double t139 = rpars[18]*rpars[18];
  double t140 = rpars[19]*rpars[19];
  double t141 = rpars[3]*t105*4.0;
  double t142 = rpars[2]*rpars[15]*8.0;
  double t143 = t56*t103*2.0;
  double t144 = t49*t106*2.0;
  double t145 = t31*t75*2.0;
  double t146 = rpars[17]*t87*4.0;
  double t147 = t33*t79*2.0;
  double t148 = rpars[7]*rpars[14]*8.0;
  double t149 = t64*t85*2.0;
  double t150 = t66*t87*2.0;
  double t151 = t29*t88*2.0;
  double t152 = rpars[15]*t103*4.0;
  double t153 = rpars[3]*rpars[19]*8.0;
  double t154 = rpars[7]*t30*4.0;
  double t155 = rpars[6]*t66*4.0;
  double t156 = rpars[2]*t56*4.0;
  double t157 = t32*t66*2.0;
  double t158 = rpars[5]*t101*4.0;
  double t159 = rpars[18]*t106*4.0;
  double t160 = t29*t122*2.0;
  double t161 = t33*t112*2.0;
  double t162 = rpars[19]*t105*4.0;
  double t163 = rpars[18]*t36*4.0;
  double t164 = t29*t132*2.0;
  double t165 = t37*t116*2.0;
  double t166 = rpars[7]*t85*4.0;
  double t167 = t75*t101*2.0;
  double t168 = t74*t105*2.0;
  double t169 = t47*2.0;
  double t170 = t35*t105*2.0;
  double t171 = t36*t106*2.0;
  double t172 = t85*t85;
  double t173 = t87*t87;
  double t174 = t107*4.0;
  double t175 = t108*4.0;
  double t176 = t139*4.0;
  double t177 = t140*4.0;
  double t178 = t33*t134*2.0;
  double t179 = t37*t133*2.0;
  double t180 = rpars[6]*t87*4.0;
  double t181 = rpars[13]*t101*4.0;
  double t182 = rpars[7]*t64*4.0;
  double t183 = rpars[5]*t75*4.0;
  double t184 = t32*t87*2.0;
  double t185 = t101*t101;
  double t186 = t105*t105;
  double t187 = t89*4.0;
  double t188 = t90*4.0;
  double t189 = t137*4.0;
  double t190 = t138*4.0;
  double t191 = rpars[2]*t103*4.0;
  double t192 = rpars[1]*t106*4.0;
  double t193 = rpars[3]*t74*4.0;
  double t194 = rpars[1]*t49*4.0;
  double t195 = rpars[17]*t32*4.0;
  double t196 = rpars[13]*t31*4.0;
  double t197 = t103*t103;
  double t198 = t106*t106;
  double t199 = t57*4.0;
  double t200 = t58*4.0;
  double t201 = t135*4.0;
  double t202 = t136*4.0;
  *(vars[0]) = rpars[9]*rpars[9]+rpars[10]*rpars[10]+rpars[11]*rpars[11];
  *(vars[1]) = rpars[1]*rpars[10]*2.0+rpars[2]*rpars[11]*2.0+rpars[9]*t8*2.0;
  *(vars[2]) = rpars[3]*rpars[9]*2.0+rpars[5]*rpars[11]*2.0+rpars[10]*t9*2.0;
  *(vars[3]) = rpars[6]*rpars[9]*2.0+rpars[7]*rpars[10]*2.0+rpars[11]*t10*2.0;
  *(vars[4]) = rpars[9]*rpars[21]*-2.0-rpars[10]*rpars[22]*2.0-rpars[11]*rpars[23]*2.0;
  *(vars[5]) = t6-rpars[11]*rpars[22]*4.0;
  *(vars[6]) = t3-rpars[9]*rpars[23]*4.0;
  *(vars[7]) = t2-rpars[10]*rpars[21]*4.0;
  *(vars[8]) = t4+t5-rpars[9]*rpars[21]*2.0;
  *(vars[9]) = -t2-rpars[10]*rpars[21]*4.0;
  *(vars[10]) = -t3-rpars[9]*rpars[23]*4.0;
  *(vars[11]) = -t4+t5+t7;
  *(vars[12]) = -t6-rpars[11]*rpars[22]*4.0;
  *(vars[13]) = t4-t5+t7;
  *(vars[14]) = t89+t107+t8*t8;
  *(vars[15]) = rpars[2]*rpars[5]*2.0+rpars[1]*t9*2.0+rpars[3]*t8*2.0;
  *(vars[16]) = rpars[1]*rpars[7]*2.0+rpars[2]*t10*2.0+rpars[6]*t8*2.0;
  *(vars[17]) = t57+t108+t9*t9;
  *(vars[18]) = rpars[3]*rpars[6]*2.0+rpars[5]*t10*2.0+rpars[7]*t9*2.0;
  *(vars[19]) = t58+t90+t10*t10;
  *(vars[20]) = rpars[1]*rpars[22]*-2.0-rpars[2]*rpars[23]*2.0-rpars[21]*t8*2.0;
  *(vars[21]) = rpars[3]*rpars[21]*-2.0-rpars[5]*rpars[23]*2.0-rpars[22]*t9*2.0;
  *(vars[22]) = rpars[6]*rpars[21]*-2.0-rpars[7]*rpars[22]*2.0-rpars[23]*t10*2.0;
  *(vars[23]) = t23-rpars[2]*rpars[22]*4.0;
  *(vars[24]) = t24-rpars[5]*rpars[22]*4.0;
  *(vars[25]) = t25-rpars[22]*t10*4.0;
  *(vars[26]) = t14-rpars[23]*t8*4.0;
  *(vars[27]) = t15-rpars[3]*rpars[23]*4.0;
  *(vars[28]) = t16-rpars[6]*rpars[23]*4.0;
  *(vars[29]) = t11-rpars[1]*rpars[21]*4.0;
  *(vars[30]) = t12-rpars[21]*t9*4.0;
  *(vars[31]) = t13-rpars[7]*rpars[21]*4.0;
  *(vars[32]) = t17+t18-rpars[21]*t8*2.0;
  *(vars[33]) = t19+t20-rpars[3]*rpars[21]*2.0;
  *(vars[34]) = t21+t22-rpars[6]*rpars[21]*2.0;
  *(vars[35]) = -t11-rpars[1]*rpars[21]*4.0;
  *(vars[36]) = -t12-rpars[21]*t9*4.0;
  *(vars[37]) = -t13-rpars[7]*rpars[21]*4.0;
  *(vars[38]) = -t14-rpars[23]*t8*4.0;
  *(vars[39]) = -t15-rpars[3]*rpars[23]*4.0;
  *(vars[40]) = -t16-rpars[6]*rpars[23]*4.0;
  *(vars[41]) = -t17+t18+t26;
  *(vars[42]) = t19-t20+t27;
  *(vars[43]) = -t21+t22+t28;
  *(vars[44]) = -t23-rpars[2]*rpars[22]*4.0;
  *(vars[45]) = -t24-rpars[5]*rpars[22]*4.0;
  *(vars[46]) = -t25-rpars[22]*t10*4.0;
  *(vars[47]) = t17-t18+t26;
  *(vars[48]) = -t19+t20+t27;
  *(vars[49]) = t21-t22+t28;
  *(vars[50]) = t43+t44+t45+t46+t47+t59+t60+t61+t83+t84+t98+t99;
  *(vars[51]) = t94+t96+t97+t109-rpars[3]*t35*4.0-rpars[13]*t31*4.0-t36*t49*2.0-t37*t52*2.0;
  *(vars[52]) = t78+t80+t81+t111-rpars[7]*t30*4.0-rpars[17]*t32*4.0-t31*t75*2.0-t29*t88*2.0;
  *(vars[53]) = t65+t72+t73+t115-rpars[2]*t34*4.0-rpars[18]*t36*4.0-t32*t66*2.0-t33*t79*2.0;
  *(vars[54]) = t44*-2.0-t45*2.0-t46*2.0-t47*2.0+t82+t86+t91+t92+t93+t102+t130+t131+t199+t200+t201+t202-t32*t87*2.0-t35*t105*2.0+t52*t52+t55*t55;
  *(vars[55]) = t65+t72-t73+t117+t118+t119+t157+t160+t161-rpars[7]*rpars[14]*8.0-rpars[6]*rpars[17]*
         8.0-rpars[1]*t49*4.0-rpars[18]*t36*4.0-rpars[3]*t74*4.0-t52*t71*2.0;
  *(vars[56]) = t78+t80-t81+t113+t114+t145+t154+t164+t165-rpars[5]*rpars[13]*8.0-rpars[3]*rpars[19]*
         8.0-rpars[17]*t32*4.0-rpars[2]*t56*4.0-rpars[6]*t66*4.0-t55*t79*2.0;
  *(vars[57]) = t47*-2.0-t82-t83*2.0-t84*2.0-t86+t91+t92+t93+t100+t104+t128+t129+t184+t187+t188+t189+t190-t36*t106*2.0+t71*t71+t88*t88;
  *(vars[58]) = t94+t96-t97+t110+t123+t124+t125+t178+t179-rpars[2]*rpars[15]*8.0-rpars[1]*rpars[18]*
         8.0-rpars[13]*t31*4.0-rpars[7]*t64*4.0-rpars[5]*t75*4.0-t88*t95*2.0;
  *(vars[59]) = -t82+t91+t92+t93-t98*2.0-t99*2.0-t100-t102-t104+t126+t127+t169+t170+t171+t174+t175+t176+t177+t79*t79+t95*t95;
  *(vars[60]) = -t94-t109+t110+t120+t121+t141-rpars[6]*t87*4.0-rpars[13]*t101*4.0;
  *(vars[61]) = -t80-t81-t111+t113+t114+t146+t153+t155+t156-rpars[5]*rpars[13]*8.0-rpars[7]*t85*4.0-
         t29*t88*2.0+t55*t112*2.0-t75*t101*2.0-t74*t105*2.0;
  *(vars[62]) = t115+t117-t118-t119+t147+t148+t149+t150+t158+t163-rpars[6]*rpars[17]*8.0-rpars[1]*
         t49*4.0-rpars[3]*t74*4.0-rpars[19]*t105*4.0-t52*t116*2.0;
  *(vars[63]) = t109+t120-t121+t123-t124-t125+t142+t143+t144+t180+t196-rpars[1]*rpars[18]*8.0-rpars[7]*t64*4.0-rpars[5]*t75*4.0-t88*t122*2.0;
  *(vars[64]) = t57*-8.0+t58*8.0+t89*8.0-t90*8.0-t107*8.0+t108*8.0-t126*2.0+t127*2.0+t128*2.0-t129*
         2.0-t130*2.0+t131*2.0+t135*8.0-t136*8.0-t137*8.0+t138*8.0+t139*8.0-t140*8.0-t52*t133*2.0+t71*t116*
         2.0+t55*t134*2.0-t79*t112*2.0+t95*t122*2.0-t88*t132*2.0;
  *(vars[65]) = -t96-t97-t109-t120+t124+t125-t141+t142-t143-t144+t181+t182+t183-rpars[1]*rpars[18]*8.0+t95*t132*2.0;
  *(vars[66]) = -t78-t111+t145-t146+t151+t152+t166-rpars[1]*t106*4.0;
  *(vars[67]) = -t72-t73-t115+t118+t119-t147+t148-t149-t150+t159+t193+t194-rpars[6]*rpars[17]*8.0-rpars[2]*t103*4.0+t71*t133*2.0;
  *(vars[68]) = t111-t113-t114+t151-t152+t153+t154-t155-t156+t167+t168+t192+t195-rpars[5]*rpars[13]*8.0-t79*t134*2.0;
  *(vars[69]) = -t65-t115+t147+t157-t158-t159+t162+t191;
  *(vars[70]) = t43+t44+t45+t46+t47+t59+t60+t61+t172+t173+t185+t186;
  *(vars[71]) = -t117+t149-t150+t158+t160-t161+t162+t163;
  *(vars[72]) = -t80+t81+t146+t164-t165+t166+t167-t168;
  *(vars[73]) = -t82+t91+t92+t93-t100-t102-t104+t126+t127+t169+t170+t171-t172*2.0-t173*2.0+t174+t175+t176+t177+t112*t112+t122*t122;
  *(vars[74]) = -t94-t110-t121-t124-t125-t141-t142-t178-t179-t180-t181+t182+t183-rpars[1]*rpars[18]*8.0+t122*t132*2.0;
  *(vars[75]) = -t82-t86+t91+t92+t93+t100+t104+t128+t129-t169-t171+t184-t185*2.0-t186*2.0+t187+t188+t189+t190+t116*t116+t132*t132;
  *(vars[76]) = -t72+t73-t149+t150+t159-t160+t161+t191;
  *(vars[77]) = -t78-t113-t114-t145-t146-t152-t153+t155+t156-t164-t165-t166-t192-rpars[5]*rpars[13]*8.0+t112*t134*2.0;
  *(vars[78]) = -t65-t118-t119-t148-t157-t158-t159-t160-t161-t162-t191+t193+t194-rpars[6]*rpars[17]*8.0+t116*t133*2.0;
  *(vars[79]) = t152-t154-t164+t165-t167+t168+t192+t195;
  *(vars[80]) = t43+t44+t47+t59+t60+t61+t83+t84+t172+t173+t197+t198;
  *(vars[81]) = t121-t123+t143-t144+t178-t179+t180+t196;
  *(vars[82]) = t82+t86+t91+t92+t93-t100+t102+t130+t131-t169-t170-t184-t197*2.0-t198*2.0+t199+t200+t201+t202+t133*t133+t134*t134;
  *(vars[83]) = -t96+t97+t141-t143+t144-t178+t179+t181;
  *(vars[84]) = t43+t44+t47+t59+t60+t61+t98+t99+t185+t186+t197+t198;
}

void HecProblem::evalSdpConstraintsVariables(const double *pars, const double *vmul, double **vars) const {

  double aux[2];

  updateAuxiliaries(pars, aux);

  *(vars[0]) = vmul[0] * (aux[0]);  *(vars[1]) = vmul[1] * (aux[0]);  *(vars[2]) = vmul[2] * (aux[0]);  *(vars[3]) = vmul[3] * (aux[0]);
  *(vars[4]) = vmul[4] * (aux[0]);  *(vars[5]) = vmul[5] * (aux[0]);  *(vars[6]) = vmul[6] * (aux[0]);  *(vars[7]) = vmul[7] * (aux[0]);
  *(vars[8]) = vmul[8] * (aux[0]);  *(vars[9]) = vmul[9] * (aux[0]);  *(vars[10]) = vmul[10] * (aux[0]);  *(vars[11]) = vmul[11] * (aux[0]);
  *(vars[12]) = vmul[12] * (aux[0]);  *(vars[13]) = vmul[13] * (aux[0]);  *(vars[14]) = vmul[14] * (aux[0]);  *(vars[15]) = vmul[15] * (aux[0]);
  *(vars[16]) = vmul[16] * (aux[0]);  *(vars[17]) = vmul[17] * (aux[0]);  *(vars[18]) = vmul[18] * (aux[0]);  *(vars[19]) = vmul[19] * (aux[0]);
  *(vars[20]) = vmul[20] * (aux[0]);  *(vars[21]) = vmul[21] * (aux[0]);  *(vars[22]) = vmul[22] * (aux[0]);  *(vars[23]) = vmul[23] * (aux[0]);
  *(vars[24]) = vmul[24] * (aux[0]);  *(vars[25]) = vmul[25] * (aux[0]);  *(vars[26]) = vmul[26] * (aux[0]);  *(vars[27]) = vmul[27] * (aux[0]);
  *(vars[28]) = vmul[28] * (aux[0]);  *(vars[29]) = vmul[29] * (aux[0]);  *(vars[30]) = vmul[30] * (aux[0]);  *(vars[31]) = vmul[31] * (aux[0]);
  *(vars[32]) = vmul[32] * (aux[0]);  *(vars[33]) = vmul[33] * (aux[0]);  *(vars[34]) = vmul[34] * (aux[0]);  *(vars[35]) = vmul[35] * (aux[0]);
}

const int HecProblem::num_blocks = 5;
const int HecProblem::num_cons = 329;
const int HecProblem::num_pcons = 4;
const int HecProblem::num_pvars = 7;
const int HecProblem::num_rpars = 24;
const int HecProblem::num_ppars = 1;
const int HecProblem::problem_size = 68;
const int HecProblem::relax_order = 2;
const int HecProblem::max_degree = 4;
const int HecProblem::rank_shift = 1;
const int HecProblem::block_sizes[] = {36, 8, 8, 8, 8};

const int HecProblem::num_obj_data = 85;
const int HecProblem::num_obj_vars = 85;
const HecProblem::objData  HecProblem::obj_data[] = {
  {0, 0.0},  {5, 0.0},  {6, 0.0},  {7, 0.0},  {8, 0.0},  {9, 0.0},
  {10, 0.0},  {11, 0.0},  {15, 0.0},  {16, 0.0},  {17, 0.0},  {21, 0.0},
  {22, 0.0},  {26, 0.0},  {30, 0.0},  {31, 0.0},  {32, 0.0},  {33, 0.0},
  {34, 0.0},  {35, 0.0},  {40, 0.0},  {41, 0.0},  {42, 0.0},  {46, 0.0},
  {47, 0.0},  {48, 0.0},  {51, 0.0},  {52, 0.0},  {53, 0.0},  {55, 0.0},
  {56, 0.0},  {57, 0.0},  {67, 0.0},  {68, 0.0},  {69, 0.0},  {72, 0.0},
  {73, 0.0},  {74, 0.0},  {76, 0.0},  {77, 0.0},  {78, 0.0},  {87, 0.0},
  {88, 0.0},  {89, 0.0},  {91, 0.0},  {92, 0.0},  {93, 0.0},  {101, 0.0},
  {102, 0.0},  {103, 0.0},  {120, 0.0},  {121, 0.0},  {122, 0.0},  {123, 0.0},
  {127, 0.0},  {128, 0.0},  {129, 0.0},  {133, 0.0},  {134, 0.0},  {138, 0.0},
  {148, 0.0},  {149, 0.0},  {150, 0.0},  {154, 0.0},  {155, 0.0},  {159, 0.0},
  {169, 0.0},  {170, 0.0},  {174, 0.0},  {184, 0.0},  {204, 0.0},  {205, 0.0},
  {206, 0.0},  {210, 0.0},  {211, 0.0},  {215, 0.0},  {225, 0.0},  {226, 0.0},
  {230, 0.0},  {240, 0.0},  {260, 0.0},  {261, 0.0},  {265, 0.0},  {275, 0.0},
  {295, 0.0}
};
const HecProblem::objVar HecProblem::obj_vars[] = {
  {0},  {5},  {6},  {7},  {8},  {9},
  {10},  {11},  {15},  {16},  {17},  {21},
  {22},  {26},  {30},  {31},  {32},  {33},
  {34},  {35},  {40},  {41},  {42},  {46},
  {47},  {48},  {51},  {52},  {53},  {55},
  {56},  {57},  {67},  {68},  {69},  {72},
  {73},  {74},  {76},  {77},  {78},  {87},
  {88},  {89},  {91},  {92},  {93},  {101},
  {102},  {103},  {120},  {121},  {122},  {123},
  {127},  {128},  {129},  {133},  {134},  {138},
  {148},  {149},  {150},  {154},  {155},  {159},
  {169},  {170},  {174},  {184},  {204},  {205},
  {206},  {210},  {211},  {215},  {225},  {226},
  {230},  {240},  {260},  {261},  {265},  {275},
  {295}
};

const int HecProblem::num_con_data = 1206;
const int HecProblem::num_con_vars = 36;
const HecProblem::conData HecProblem::con_data[] = {
  {0, 0, 0, 0, 1.0},  {0, 1, 0, 1, 1.0},  {0, 2, 0, 2, 1.0},  {0, 3, 0, 3, 1.0},  {0, 4, 0, 4, 1.0},
  {0, 5, 0, 5, 1.0},  {0, 6, 0, 6, 1.0},  {0, 7, 0, 7, 1.0},  {0, 8, 0, 8, 1.0},  {0, 8, 1, 1, 1.0},  {0, 9, 0, 9, 1.0},
  {0, 9, 1, 2, 1.0},  {0, 10, 0, 10, 1.0},  {0, 10, 1, 3, 1.0},  {0, 11, 0, 11, 1.0},  {0, 11, 1, 4, 1.0},  {0, 12, 0, 12, 1.0},
  {0, 12, 1, 5, 1.0},  {0, 13, 0, 13, 1.0},  {0, 13, 1, 6, 1.0},  {0, 14, 0, 14, 1.0},  {0, 14, 1, 7, 1.0},  {0, 15, 0, 15, 1.0},
  {0, 15, 2, 2, 1.0},  {0, 16, 0, 16, 1.0},  {0, 16, 2, 3, 1.0},  {0, 17, 0, 17, 1.0},  {0, 17, 2, 4, 1.0},  {0, 18, 0, 18, 1.0},
  {0, 18, 2, 5, 1.0},  {0, 19, 0, 19, 1.0},  {0, 19, 2, 6, 1.0},  {0, 20, 0, 20, 1.0},  {0, 20, 2, 7, 1.0},  {0, 21, 0, 21, 1.0},
  {0, 21, 3, 3, 1.0},  {0, 22, 0, 22, 1.0},  {0, 22, 3, 4, 1.0},  {0, 23, 0, 23, 1.0},  {0, 23, 3, 5, 1.0},  {0, 24, 0, 24, 1.0},
  {0, 24, 3, 6, 1.0},  {0, 25, 0, 25, 1.0},  {0, 25, 3, 7, 1.0},  {0, 26, 0, 26, 1.0},  {0, 26, 4, 4, 1.0},  {0, 27, 0, 27, 1.0},
  {0, 27, 4, 5, 1.0},  {0, 28, 0, 28, 1.0},  {0, 28, 4, 6, 1.0},  {0, 29, 0, 29, 1.0},  {0, 29, 4, 7, 1.0},  {0, 30, 0, 30, 1.0},
  {0, 30, 5, 5, 1.0},  {0, 31, 0, 31, 1.0},  {0, 31, 5, 6, 1.0},  {0, 32, 0, 32, 1.0},  {0, 32, 5, 7, 1.0},  {0, 33, 0, 33, 1.0},
  {0, 33, 6, 6, 1.0},  {0, 34, 0, 34, 1.0},  {0, 34, 6, 7, 1.0},  {0, 35, 0, 35, 1.0},  {0, 35, 7, 7, 1.0},  {0, 36, 1, 8, 1.0},
  {0, 37, 1, 9, 1.0},  {0, 37, 2, 8, 1.0},  {0, 38, 1, 10, 1.0},  {0, 38, 3, 8, 1.0},  {0, 39, 1, 11, 1.0},  {0, 39, 4, 8, 1.0},
  {0, 40, 1, 12, 1.0},  {0, 40, 5, 8, 1.0},  {0, 41, 1, 13, 1.0},  {0, 41, 6, 8, 1.0},  {0, 42, 1, 14, 1.0},  {0, 42, 7, 8, 1.0},
  {0, 43, 1, 15, 1.0},  {0, 43, 2, 9, 1.0},  {0, 44, 1, 16, 1.0},  {0, 44, 2, 10, 1.0},  {0, 44, 3, 9, 1.0},  {0, 45, 1, 17, 1.0},
  {0, 45, 2, 11, 1.0},  {0, 45, 4, 9, 1.0},  {0, 46, 1, 18, 1.0},  {0, 46, 2, 12, 1.0},  {0, 46, 5, 9, 1.0},  {0, 47, 1, 19, 1.0},
  {0, 47, 2, 13, 1.0},  {0, 47, 6, 9, 1.0},  {0, 48, 1, 20, 1.0},  {0, 48, 2, 14, 1.0},  {0, 48, 7, 9, 1.0},  {0, 49, 1, 21, 1.0},
  {0, 49, 3, 10, 1.0},  {0, 50, 1, 22, 1.0},  {0, 50, 3, 11, 1.0},  {0, 50, 4, 10, 1.0},  {0, 51, 1, 23, 1.0},  {0, 51, 3, 12, 1.0},
  {0, 51, 5, 10, 1.0},  {0, 52, 1, 24, 1.0},  {0, 52, 3, 13, 1.0},  {0, 52, 6, 10, 1.0},  {0, 53, 1, 25, 1.0},  {0, 53, 3, 14, 1.0},
  {0, 53, 7, 10, 1.0},  {0, 54, 1, 26, 1.0},  {0, 54, 4, 11, 1.0},  {0, 55, 1, 27, 1.0},  {0, 55, 4, 12, 1.0},  {0, 55, 5, 11, 1.0},
  {0, 56, 1, 28, 1.0},  {0, 56, 4, 13, 1.0},  {0, 56, 6, 11, 1.0},  {0, 57, 1, 29, 1.0},  {0, 57, 4, 14, 1.0},  {0, 57, 7, 11, 1.0},
  {0, 58, 1, 30, 1.0},  {0, 58, 5, 12, 1.0},  {0, 59, 1, 31, 1.0},  {0, 59, 5, 13, 1.0},  {0, 59, 6, 12, 1.0},  {0, 60, 1, 32, 1.0},
  {0, 60, 5, 14, 1.0},  {0, 60, 7, 12, 1.0},  {0, 61, 1, 33, 1.0},  {0, 61, 6, 13, 1.0},  {0, 62, 1, 34, 1.0},  {0, 62, 6, 14, 1.0},
  {0, 62, 7, 13, 1.0},  {0, 63, 1, 35, 1.0},  {0, 63, 7, 14, 1.0},  {0, 64, 2, 15, 1.0},  {0, 65, 2, 16, 1.0},  {0, 65, 3, 15, 1.0},
  {0, 66, 2, 17, 1.0},  {0, 66, 4, 15, 1.0},  {0, 67, 2, 18, 1.0},  {0, 67, 5, 15, 1.0},  {0, 68, 2, 19, 1.0},  {0, 68, 6, 15, 1.0},
  {0, 69, 2, 20, 1.0},  {0, 69, 7, 15, 1.0},  {0, 70, 2, 21, 1.0},  {0, 70, 3, 16, 1.0},  {0, 71, 2, 22, 1.0},  {0, 71, 3, 17, 1.0},
  {0, 71, 4, 16, 1.0},  {0, 72, 2, 23, 1.0},  {0, 72, 3, 18, 1.0},  {0, 72, 5, 16, 1.0},  {0, 73, 2, 24, 1.0},  {0, 73, 3, 19, 1.0},
  {0, 73, 6, 16, 1.0},  {0, 74, 2, 25, 1.0},  {0, 74, 3, 20, 1.0},  {0, 74, 7, 16, 1.0},  {0, 75, 2, 26, 1.0},  {0, 75, 4, 17, 1.0},
  {0, 76, 2, 27, 1.0},  {0, 76, 4, 18, 1.0},  {0, 76, 5, 17, 1.0},  {0, 77, 2, 28, 1.0},  {0, 77, 4, 19, 1.0},  {0, 77, 6, 17, 1.0},
  {0, 78, 2, 29, 1.0},  {0, 78, 4, 20, 1.0},  {0, 78, 7, 17, 1.0},  {0, 79, 2, 30, 1.0},  {0, 79, 5, 18, 1.0},  {0, 80, 2, 31, 1.0},
  {0, 80, 5, 19, 1.0},  {0, 80, 6, 18, 1.0},  {0, 81, 2, 32, 1.0},  {0, 81, 5, 20, 1.0},  {0, 81, 7, 18, 1.0},  {0, 82, 2, 33, 1.0},
  {0, 82, 6, 19, 1.0},  {0, 83, 2, 34, 1.0},  {0, 83, 6, 20, 1.0},  {0, 83, 7, 19, 1.0},  {0, 84, 2, 35, 1.0},  {0, 84, 7, 20, 1.0},
  {0, 85, 3, 21, 1.0},  {0, 86, 3, 22, 1.0},  {0, 86, 4, 21, 1.0},  {0, 87, 3, 23, 1.0},  {0, 87, 5, 21, 1.0},  {0, 88, 3, 24, 1.0},
  {0, 88, 6, 21, 1.0},  {0, 89, 3, 25, 1.0},  {0, 89, 7, 21, 1.0},  {0, 90, 3, 26, 1.0},  {0, 90, 4, 22, 1.0},  {0, 91, 3, 27, 1.0},
  {0, 91, 4, 23, 1.0},  {0, 91, 5, 22, 1.0},  {0, 92, 3, 28, 1.0},  {0, 92, 4, 24, 1.0},  {0, 92, 6, 22, 1.0},  {0, 93, 3, 29, 1.0},
  {0, 93, 4, 25, 1.0},  {0, 93, 7, 22, 1.0},  {0, 94, 3, 30, 1.0},  {0, 94, 5, 23, 1.0},  {0, 95, 3, 31, 1.0},  {0, 95, 5, 24, 1.0},
  {0, 95, 6, 23, 1.0},  {0, 96, 3, 32, 1.0},  {0, 96, 5, 25, 1.0},  {0, 96, 7, 23, 1.0},  {0, 97, 3, 33, 1.0},  {0, 97, 6, 24, 1.0},
  {0, 98, 3, 34, 1.0},  {0, 98, 6, 25, 1.0},  {0, 98, 7, 24, 1.0},  {0, 99, 3, 35, 1.0},  {0, 99, 7, 25, 1.0},  {0, 100, 4, 26, 1.0},
  {0, 101, 4, 27, 1.0},  {0, 101, 5, 26, 1.0},  {0, 102, 4, 28, 1.0},  {0, 102, 6, 26, 1.0},  {0, 103, 4, 29, 1.0},  {0, 103, 7, 26, 1.0},
  {0, 104, 4, 30, 1.0},  {0, 104, 5, 27, 1.0},  {0, 105, 4, 31, 1.0},  {0, 105, 5, 28, 1.0},  {0, 105, 6, 27, 1.0},  {0, 106, 4, 32, 1.0},
  {0, 106, 5, 29, 1.0},  {0, 106, 7, 27, 1.0},  {0, 107, 4, 33, 1.0},  {0, 107, 6, 28, 1.0},  {0, 108, 4, 34, 1.0},  {0, 108, 6, 29, 1.0},
  {0, 108, 7, 28, 1.0},  {0, 109, 4, 35, 1.0},  {0, 109, 7, 29, 1.0},  {0, 110, 5, 30, 1.0},  {0, 111, 5, 31, 1.0},  {0, 111, 6, 30, 1.0},
  {0, 112, 5, 32, 1.0},  {0, 112, 7, 30, 1.0},  {0, 113, 5, 33, 1.0},  {0, 113, 6, 31, 1.0},  {0, 114, 5, 34, 1.0},  {0, 114, 6, 32, 1.0},
  {0, 114, 7, 31, 1.0},  {0, 115, 5, 35, 1.0},  {0, 115, 7, 32, 1.0},  {0, 116, 6, 33, 1.0},  {0, 117, 6, 34, 1.0},  {0, 117, 7, 33, 1.0},
  {0, 118, 6, 35, 1.0},  {0, 118, 7, 34, 1.0},  {0, 119, 7, 35, 1.0},  {0, 120, 8, 8, 1.0},  {0, 121, 8, 9, 1.0},  {0, 122, 8, 10, 1.0},
  {0, 123, 8, 11, 1.0},  {0, 124, 8, 12, 1.0},  {0, 125, 8, 13, 1.0},  {0, 126, 8, 14, 1.0},  {0, 127, 8, 15, 1.0},  {0, 127, 9, 9, 1.0},
  {0, 128, 8, 16, 1.0},  {0, 128, 9, 10, 1.0},  {0, 129, 8, 17, 1.0},  {0, 129, 9, 11, 1.0},  {0, 130, 8, 18, 1.0},  {0, 130, 9, 12, 1.0},
  {0, 131, 8, 19, 1.0},  {0, 131, 9, 13, 1.0},  {0, 132, 8, 20, 1.0},  {0, 132, 9, 14, 1.0},  {0, 133, 8, 21, 1.0},  {0, 133, 10, 10, 1.0},
  {0, 134, 8, 22, 1.0},  {0, 134, 10, 11, 1.0},  {0, 135, 8, 23, 1.0},  {0, 135, 10, 12, 1.0},  {0, 136, 8, 24, 1.0},  {0, 136, 10, 13, 1.0},
  {0, 137, 8, 25, 1.0},  {0, 137, 10, 14, 1.0},  {0, 138, 8, 26, 1.0},  {0, 138, 11, 11, 1.0},  {0, 139, 8, 27, 1.0},  {0, 139, 11, 12, 1.0},
  {0, 140, 8, 28, 1.0},  {0, 140, 11, 13, 1.0},  {0, 141, 8, 29, 1.0},  {0, 141, 11, 14, 1.0},  {0, 142, 8, 30, 1.0},  {0, 142, 12, 12, 1.0},
  {0, 143, 8, 31, 1.0},  {0, 143, 12, 13, 1.0},  {0, 144, 8, 32, 1.0},  {0, 144, 12, 14, 1.0},  {0, 145, 8, 33, 1.0},  {0, 145, 13, 13, 1.0},
  {0, 146, 8, 34, 1.0},  {0, 146, 13, 14, 1.0},  {0, 147, 8, 35, 1.0},  {0, 147, 14, 14, 1.0},  {0, 148, 9, 15, 1.0},  {0, 149, 9, 16, 1.0},
  {0, 149, 10, 15, 1.0},  {0, 150, 9, 17, 1.0},  {0, 150, 11, 15, 1.0},  {0, 151, 9, 18, 1.0},  {0, 151, 12, 15, 1.0},  {0, 152, 9, 19, 1.0},
  {0, 152, 13, 15, 1.0},  {0, 153, 9, 20, 1.0},  {0, 153, 14, 15, 1.0},  {0, 154, 9, 21, 1.0},  {0, 154, 10, 16, 1.0},  {0, 155, 9, 22, 1.0},
  {0, 155, 10, 17, 1.0},  {0, 155, 11, 16, 1.0},  {0, 156, 9, 23, 1.0},  {0, 156, 10, 18, 1.0},  {0, 156, 12, 16, 1.0},  {0, 157, 9, 24, 1.0},
  {0, 157, 10, 19, 1.0},  {0, 157, 13, 16, 1.0},  {0, 158, 9, 25, 1.0},  {0, 158, 10, 20, 1.0},  {0, 158, 14, 16, 1.0},  {0, 159, 9, 26, 1.0},
  {0, 159, 11, 17, 1.0},  {0, 160, 9, 27, 1.0},  {0, 160, 11, 18, 1.0},  {0, 160, 12, 17, 1.0},  {0, 161, 9, 28, 1.0},  {0, 161, 11, 19, 1.0},
  {0, 161, 13, 17, 1.0},  {0, 162, 9, 29, 1.0},  {0, 162, 11, 20, 1.0},  {0, 162, 14, 17, 1.0},  {0, 163, 9, 30, 1.0},  {0, 163, 12, 18, 1.0},
  {0, 164, 9, 31, 1.0},  {0, 164, 12, 19, 1.0},  {0, 164, 13, 18, 1.0},  {0, 165, 9, 32, 1.0},  {0, 165, 12, 20, 1.0},  {0, 165, 14, 18, 1.0},
  {0, 166, 9, 33, 1.0},  {0, 166, 13, 19, 1.0},  {0, 167, 9, 34, 1.0},  {0, 167, 13, 20, 1.0},  {0, 167, 14, 19, 1.0},  {0, 168, 9, 35, 1.0},
  {0, 168, 14, 20, 1.0},  {0, 169, 10, 21, 1.0},  {0, 170, 10, 22, 1.0},  {0, 170, 11, 21, 1.0},  {0, 171, 10, 23, 1.0},  {0, 171, 12, 21, 1.0},
  {0, 172, 10, 24, 1.0},  {0, 172, 13, 21, 1.0},  {0, 173, 10, 25, 1.0},  {0, 173, 14, 21, 1.0},  {0, 174, 10, 26, 1.0},  {0, 174, 11, 22, 1.0},
  {0, 175, 10, 27, 1.0},  {0, 175, 11, 23, 1.0},  {0, 175, 12, 22, 1.0},  {0, 176, 10, 28, 1.0},  {0, 176, 11, 24, 1.0},  {0, 176, 13, 22, 1.0},
  {0, 177, 10, 29, 1.0},  {0, 177, 11, 25, 1.0},  {0, 177, 14, 22, 1.0},  {0, 178, 10, 30, 1.0},  {0, 178, 12, 23, 1.0},  {0, 179, 10, 31, 1.0},
  {0, 179, 12, 24, 1.0},  {0, 179, 13, 23, 1.0},  {0, 180, 10, 32, 1.0},  {0, 180, 12, 25, 1.0},  {0, 180, 14, 23, 1.0},  {0, 181, 10, 33, 1.0},
  {0, 181, 13, 24, 1.0},  {0, 182, 10, 34, 1.0},  {0, 182, 13, 25, 1.0},  {0, 182, 14, 24, 1.0},  {0, 183, 10, 35, 1.0},  {0, 183, 14, 25, 1.0},
  {0, 184, 11, 26, 1.0},  {0, 185, 11, 27, 1.0},  {0, 185, 12, 26, 1.0},  {0, 186, 11, 28, 1.0},  {0, 186, 13, 26, 1.0},  {0, 187, 11, 29, 1.0},
  {0, 187, 14, 26, 1.0},  {0, 188, 11, 30, 1.0},  {0, 188, 12, 27, 1.0},  {0, 189, 11, 31, 1.0},  {0, 189, 12, 28, 1.0},  {0, 189, 13, 27, 1.0},
  {0, 190, 11, 32, 1.0},  {0, 190, 12, 29, 1.0},  {0, 190, 14, 27, 1.0},  {0, 191, 11, 33, 1.0},  {0, 191, 13, 28, 1.0},  {0, 192, 11, 34, 1.0},
  {0, 192, 13, 29, 1.0},  {0, 192, 14, 28, 1.0},  {0, 193, 11, 35, 1.0},  {0, 193, 14, 29, 1.0},  {0, 194, 12, 30, 1.0},  {0, 195, 12, 31, 1.0},
  {0, 195, 13, 30, 1.0},  {0, 196, 12, 32, 1.0},  {0, 196, 14, 30, 1.0},  {0, 197, 12, 33, 1.0},  {0, 197, 13, 31, 1.0},  {0, 198, 12, 34, 1.0},
  {0, 198, 13, 32, 1.0},  {0, 198, 14, 31, 1.0},  {0, 199, 12, 35, 1.0},  {0, 199, 14, 32, 1.0},  {0, 200, 13, 33, 1.0},  {0, 201, 13, 34, 1.0},
  {0, 201, 14, 33, 1.0},  {0, 202, 13, 35, 1.0},  {0, 202, 14, 34, 1.0},  {0, 203, 14, 35, 1.0},  {0, 204, 15, 15, 1.0},  {0, 205, 15, 16, 1.0},
  {0, 206, 15, 17, 1.0},  {0, 207, 15, 18, 1.0},  {0, 208, 15, 19, 1.0},  {0, 209, 15, 20, 1.0},  {0, 210, 15, 21, 1.0},  {0, 210, 16, 16, 1.0},
  {0, 211, 15, 22, 1.0},  {0, 211, 16, 17, 1.0},  {0, 212, 15, 23, 1.0},  {0, 212, 16, 18, 1.0},  {0, 213, 15, 24, 1.0},  {0, 213, 16, 19, 1.0},
  {0, 214, 15, 25, 1.0},  {0, 214, 16, 20, 1.0},  {0, 215, 15, 26, 1.0},  {0, 215, 17, 17, 1.0},  {0, 216, 15, 27, 1.0},  {0, 216, 17, 18, 1.0},
  {0, 217, 15, 28, 1.0},  {0, 217, 17, 19, 1.0},  {0, 218, 15, 29, 1.0},  {0, 218, 17, 20, 1.0},  {0, 219, 15, 30, 1.0},  {0, 219, 18, 18, 1.0},
  {0, 220, 15, 31, 1.0},  {0, 220, 18, 19, 1.0},  {0, 221, 15, 32, 1.0},  {0, 221, 18, 20, 1.0},  {0, 222, 15, 33, 1.0},  {0, 222, 19, 19, 1.0},
  {0, 223, 15, 34, 1.0},  {0, 223, 19, 20, 1.0},  {0, 224, 15, 35, 1.0},  {0, 224, 20, 20, 1.0},  {0, 225, 16, 21, 1.0},  {0, 226, 16, 22, 1.0},
  {0, 226, 17, 21, 1.0},  {0, 227, 16, 23, 1.0},  {0, 227, 18, 21, 1.0},  {0, 228, 16, 24, 1.0},  {0, 228, 19, 21, 1.0},  {0, 229, 16, 25, 1.0},
  {0, 229, 20, 21, 1.0},  {0, 230, 16, 26, 1.0},  {0, 230, 17, 22, 1.0},  {0, 231, 16, 27, 1.0},  {0, 231, 17, 23, 1.0},  {0, 231, 18, 22, 1.0},
  {0, 232, 16, 28, 1.0},  {0, 232, 17, 24, 1.0},  {0, 232, 19, 22, 1.0},  {0, 233, 16, 29, 1.0},  {0, 233, 17, 25, 1.0},  {0, 233, 20, 22, 1.0},
  {0, 234, 16, 30, 1.0},  {0, 234, 18, 23, 1.0},  {0, 235, 16, 31, 1.0},  {0, 235, 18, 24, 1.0},  {0, 235, 19, 23, 1.0},  {0, 236, 16, 32, 1.0},
  {0, 236, 18, 25, 1.0},  {0, 236, 20, 23, 1.0},  {0, 237, 16, 33, 1.0},  {0, 237, 19, 24, 1.0},  {0, 238, 16, 34, 1.0},  {0, 238, 19, 25, 1.0},
  {0, 238, 20, 24, 1.0},  {0, 239, 16, 35, 1.0},  {0, 239, 20, 25, 1.0},  {0, 240, 17, 26, 1.0},  {0, 241, 17, 27, 1.0},  {0, 241, 18, 26, 1.0},
  {0, 242, 17, 28, 1.0},  {0, 242, 19, 26, 1.0},  {0, 243, 17, 29, 1.0},  {0, 243, 20, 26, 1.0},  {0, 244, 17, 30, 1.0},  {0, 244, 18, 27, 1.0},
  {0, 245, 17, 31, 1.0},  {0, 245, 18, 28, 1.0},  {0, 245, 19, 27, 1.0},  {0, 246, 17, 32, 1.0},  {0, 246, 18, 29, 1.0},  {0, 246, 20, 27, 1.0},
  {0, 247, 17, 33, 1.0},  {0, 247, 19, 28, 1.0},  {0, 248, 17, 34, 1.0},  {0, 248, 19, 29, 1.0},  {0, 248, 20, 28, 1.0},  {0, 249, 17, 35, 1.0},
  {0, 249, 20, 29, 1.0},  {0, 250, 18, 30, 1.0},  {0, 251, 18, 31, 1.0},  {0, 251, 19, 30, 1.0},  {0, 252, 18, 32, 1.0},  {0, 252, 20, 30, 1.0},
  {0, 253, 18, 33, 1.0},  {0, 253, 19, 31, 1.0},  {0, 254, 18, 34, 1.0},  {0, 254, 19, 32, 1.0},  {0, 254, 20, 31, 1.0},  {0, 255, 18, 35, 1.0},
  {0, 255, 20, 32, 1.0},  {0, 256, 19, 33, 1.0},  {0, 257, 19, 34, 1.0},  {0, 257, 20, 33, 1.0},  {0, 258, 19, 35, 1.0},  {0, 258, 20, 34, 1.0},
  {0, 259, 20, 35, 1.0},  {0, 260, 21, 21, 1.0},  {0, 261, 21, 22, 1.0},  {0, 262, 21, 23, 1.0},  {0, 263, 21, 24, 1.0},  {0, 264, 21, 25, 1.0},
  {0, 265, 21, 26, 1.0},  {0, 265, 22, 22, 1.0},  {0, 266, 21, 27, 1.0},  {0, 266, 22, 23, 1.0},  {0, 267, 21, 28, 1.0},  {0, 267, 22, 24, 1.0},
  {0, 268, 21, 29, 1.0},  {0, 268, 22, 25, 1.0},  {0, 269, 21, 30, 1.0},  {0, 269, 23, 23, 1.0},  {0, 270, 21, 31, 1.0},  {0, 270, 23, 24, 1.0},
  {0, 271, 21, 32, 1.0},  {0, 271, 23, 25, 1.0},  {0, 272, 21, 33, 1.0},  {0, 272, 24, 24, 1.0},  {0, 273, 21, 34, 1.0},  {0, 273, 24, 25, 1.0},
  {0, 274, 21, 35, 1.0},  {0, 274, 25, 25, 1.0},  {0, 275, 22, 26, 1.0},  {0, 276, 22, 27, 1.0},  {0, 276, 23, 26, 1.0},  {0, 277, 22, 28, 1.0},
  {0, 277, 24, 26, 1.0},  {0, 278, 22, 29, 1.0},  {0, 278, 25, 26, 1.0},  {0, 279, 22, 30, 1.0},  {0, 279, 23, 27, 1.0},  {0, 280, 22, 31, 1.0},
  {0, 280, 23, 28, 1.0},  {0, 280, 24, 27, 1.0},  {0, 281, 22, 32, 1.0},  {0, 281, 23, 29, 1.0},  {0, 281, 25, 27, 1.0},  {0, 282, 22, 33, 1.0},
  {0, 282, 24, 28, 1.0},  {0, 283, 22, 34, 1.0},  {0, 283, 24, 29, 1.0},  {0, 283, 25, 28, 1.0},  {0, 284, 22, 35, 1.0},  {0, 284, 25, 29, 1.0},
  {0, 285, 23, 30, 1.0},  {0, 286, 23, 31, 1.0},  {0, 286, 24, 30, 1.0},  {0, 287, 23, 32, 1.0},  {0, 287, 25, 30, 1.0},  {0, 288, 23, 33, 1.0},
  {0, 288, 24, 31, 1.0},  {0, 289, 23, 34, 1.0},  {0, 289, 24, 32, 1.0},  {0, 289, 25, 31, 1.0},  {0, 290, 23, 35, 1.0},  {0, 290, 25, 32, 1.0},
  {0, 291, 24, 33, 1.0},  {0, 292, 24, 34, 1.0},  {0, 292, 25, 33, 1.0},  {0, 293, 24, 35, 1.0},  {0, 293, 25, 34, 1.0},  {0, 294, 25, 35, 1.0},
  {0, 295, 26, 26, 1.0},  {0, 296, 26, 27, 1.0},  {0, 297, 26, 28, 1.0},  {0, 298, 26, 29, 1.0},  {0, 299, 26, 30, 1.0},  {0, 299, 27, 27, 1.0},
  {0, 300, 26, 31, 1.0},  {0, 300, 27, 28, 1.0},  {0, 301, 26, 32, 1.0},  {0, 301, 27, 29, 1.0},  {0, 302, 26, 33, 1.0},  {0, 302, 28, 28, 1.0},
  {0, 303, 26, 34, 1.0},  {0, 303, 28, 29, 1.0},  {0, 304, 26, 35, 1.0},  {0, 304, 29, 29, 1.0},  {0, 305, 27, 30, 1.0},  {0, 306, 27, 31, 1.0},
  {0, 306, 28, 30, 1.0},  {0, 307, 27, 32, 1.0},  {0, 307, 29, 30, 1.0},  {0, 308, 27, 33, 1.0},  {0, 308, 28, 31, 1.0},  {0, 309, 27, 34, 1.0},
  {0, 309, 28, 32, 1.0},  {0, 309, 29, 31, 1.0},  {0, 310, 27, 35, 1.0},  {0, 310, 29, 32, 1.0},  {0, 311, 28, 33, 1.0},  {0, 312, 28, 34, 1.0},
  {0, 312, 29, 33, 1.0},  {0, 313, 28, 35, 1.0},  {0, 313, 29, 34, 1.0},  {0, 314, 29, 35, 1.0},  {0, 315, 30, 30, 1.0},  {0, 316, 30, 31, 1.0},
  {0, 317, 30, 32, 1.0},  {0, 318, 30, 33, 1.0},  {0, 318, 31, 31, 1.0},  {0, 319, 30, 34, 1.0},  {0, 319, 31, 32, 1.0},  {0, 320, 30, 35, 1.0},
  {0, 320, 32, 32, 1.0},  {0, 321, 31, 33, 1.0},  {0, 322, 31, 34, 1.0},  {0, 322, 32, 33, 1.0},  {0, 323, 31, 35, 1.0},  {0, 323, 32, 34, 1.0},
  {0, 324, 32, 35, 1.0},  {0, 325, 33, 33, 1.0},  {0, 326, 33, 34, 1.0},  {0, 327, 33, 35, 1.0},  {0, 327, 34, 34, 1.0},  {0, 328, 34, 35, 1.0},
  {0, 329, 35, 35, 1.0},  {1, 0, 0, 0, -1.0},  {1, 1, 0, 1, -1.0},  {1, 2, 0, 2, -1.0},  {1, 3, 0, 3, -1.0},  {1, 4, 0, 4, -1.0},
  {1, 5, 0, 5, -1.0},  {1, 6, 0, 6, -1.0},  {1, 7, 0, 7, -1.0},  {1, 8, 0, 0, 1.0},  {1, 8, 1, 1, -1.0},  {1, 9, 1, 2, -1.0},
  {1, 10, 1, 3, -1.0},  {1, 11, 1, 4, -1.0},  {1, 12, 1, 5, -1.0},  {1, 13, 1, 6, -1.0},  {1, 14, 1, 7, -1.0},  {1, 15, 0, 0, 1.0},
  {1, 15, 2, 2, -1.0},  {1, 16, 2, 3, -1.0},  {1, 17, 2, 4, -1.0},  {1, 18, 2, 5, -1.0},  {1, 19, 2, 6, -1.0},  {1, 20, 2, 7, -1.0},
  {1, 21, 0, 0, 1.0},  {1, 21, 3, 3, -1.0},  {1, 22, 3, 4, -1.0},  {1, 23, 3, 5, -1.0},  {1, 24, 3, 6, -1.0},  {1, 25, 3, 7, -1.0},
  {1, 26, 0, 0, 1.0},  {1, 26, 4, 4, -1.0},  {1, 27, 4, 5, -1.0},  {1, 28, 4, 6, -1.0},  {1, 29, 4, 7, -1.0},  {1, 30, 5, 5, -1.0},
  {1, 31, 5, 6, -1.0},  {1, 32, 5, 7, -1.0},  {1, 33, 6, 6, -1.0},  {1, 34, 6, 7, -1.0},  {1, 35, 7, 7, -1.0},  {1, 36, 0, 1, 1.0},
  {1, 37, 0, 2, 1.0},  {1, 38, 0, 3, 1.0},  {1, 39, 0, 4, 1.0},  {1, 40, 0, 5, 1.0},  {1, 41, 0, 6, 1.0},  {1, 42, 0, 7, 1.0},
  {1, 43, 0, 1, 1.0},  {1, 49, 0, 1, 1.0},  {1, 54, 0, 1, 1.0},  {1, 64, 0, 2, 1.0},  {1, 65, 0, 3, 1.0},  {1, 66, 0, 4, 1.0},
  {1, 67, 0, 5, 1.0},  {1, 68, 0, 6, 1.0},  {1, 69, 0, 7, 1.0},  {1, 70, 0, 2, 1.0},  {1, 75, 0, 2, 1.0},  {1, 85, 0, 3, 1.0},
  {1, 86, 0, 4, 1.0},  {1, 87, 0, 5, 1.0},  {1, 88, 0, 6, 1.0},  {1, 89, 0, 7, 1.0},  {1, 90, 0, 3, 1.0},  {1, 100, 0, 4, 1.0},
  {1, 101, 0, 5, 1.0},  {1, 102, 0, 6, 1.0},  {1, 103, 0, 7, 1.0},  {1, 120, 1, 1, 1.0},  {1, 121, 1, 2, 1.0},  {1, 122, 1, 3, 1.0},
  {1, 123, 1, 4, 1.0},  {1, 124, 1, 5, 1.0},  {1, 125, 1, 6, 1.0},  {1, 126, 1, 7, 1.0},  {1, 127, 1, 1, 1.0},  {1, 127, 2, 2, 1.0},
  {1, 128, 2, 3, 1.0},  {1, 129, 2, 4, 1.0},  {1, 130, 2, 5, 1.0},  {1, 131, 2, 6, 1.0},  {1, 132, 2, 7, 1.0},  {1, 133, 1, 1, 1.0},
  {1, 133, 3, 3, 1.0},  {1, 134, 3, 4, 1.0},  {1, 135, 3, 5, 1.0},  {1, 136, 3, 6, 1.0},  {1, 137, 3, 7, 1.0},  {1, 138, 1, 1, 1.0},
  {1, 138, 4, 4, 1.0},  {1, 139, 4, 5, 1.0},  {1, 140, 4, 6, 1.0},  {1, 141, 4, 7, 1.0},  {1, 142, 5, 5, 1.0},  {1, 143, 5, 6, 1.0},
  {1, 144, 5, 7, 1.0},  {1, 145, 6, 6, 1.0},  {1, 146, 6, 7, 1.0},  {1, 147, 7, 7, 1.0},  {1, 148, 1, 2, 1.0},  {1, 149, 1, 3, 1.0},
  {1, 150, 1, 4, 1.0},  {1, 151, 1, 5, 1.0},  {1, 152, 1, 6, 1.0},  {1, 153, 1, 7, 1.0},  {1, 154, 1, 2, 1.0},  {1, 159, 1, 2, 1.0},
  {1, 169, 1, 3, 1.0},  {1, 170, 1, 4, 1.0},  {1, 171, 1, 5, 1.0},  {1, 172, 1, 6, 1.0},  {1, 173, 1, 7, 1.0},  {1, 174, 1, 3, 1.0},
  {1, 184, 1, 4, 1.0},  {1, 185, 1, 5, 1.0},  {1, 186, 1, 6, 1.0},  {1, 187, 1, 7, 1.0},  {1, 204, 2, 2, 1.0},  {1, 205, 2, 3, 1.0},
  {1, 206, 2, 4, 1.0},  {1, 207, 2, 5, 1.0},  {1, 208, 2, 6, 1.0},  {1, 209, 2, 7, 1.0},  {1, 210, 2, 2, 1.0},  {1, 210, 3, 3, 1.0},
  {1, 211, 3, 4, 1.0},  {1, 212, 3, 5, 1.0},  {1, 213, 3, 6, 1.0},  {1, 214, 3, 7, 1.0},  {1, 215, 2, 2, 1.0},  {1, 215, 4, 4, 1.0},
  {1, 216, 4, 5, 1.0},  {1, 217, 4, 6, 1.0},  {1, 218, 4, 7, 1.0},  {1, 219, 5, 5, 1.0},  {1, 220, 5, 6, 1.0},  {1, 221, 5, 7, 1.0},
  {1, 222, 6, 6, 1.0},  {1, 223, 6, 7, 1.0},  {1, 224, 7, 7, 1.0},  {1, 225, 2, 3, 1.0},  {1, 226, 2, 4, 1.0},  {1, 227, 2, 5, 1.0},
  {1, 228, 2, 6, 1.0},  {1, 229, 2, 7, 1.0},  {1, 230, 2, 3, 1.0},  {1, 240, 2, 4, 1.0},  {1, 241, 2, 5, 1.0},  {1, 242, 2, 6, 1.0},
  {1, 243, 2, 7, 1.0},  {1, 260, 3, 3, 1.0},  {1, 261, 3, 4, 1.0},  {1, 262, 3, 5, 1.0},  {1, 263, 3, 6, 1.0},  {1, 264, 3, 7, 1.0},
  {1, 265, 3, 3, 1.0},  {1, 265, 4, 4, 1.0},  {1, 266, 4, 5, 1.0},  {1, 267, 4, 6, 1.0},  {1, 268, 4, 7, 1.0},  {1, 269, 5, 5, 1.0},
  {1, 270, 5, 6, 1.0},  {1, 271, 5, 7, 1.0},  {1, 272, 6, 6, 1.0},  {1, 273, 6, 7, 1.0},  {1, 274, 7, 7, 1.0},  {1, 275, 3, 4, 1.0},
  {1, 276, 3, 5, 1.0},  {1, 277, 3, 6, 1.0},  {1, 278, 3, 7, 1.0},  {1, 295, 4, 4, 1.0},  {1, 296, 4, 5, 1.0},  {1, 297, 4, 6, 1.0},
  {1, 298, 4, 7, 1.0},  {1, 299, 5, 5, 1.0},  {1, 300, 5, 6, 1.0},  {1, 301, 5, 7, 1.0},  {1, 302, 6, 6, 1.0},  {1, 303, 6, 7, 1.0},
  {1, 304, 7, 7, 1.0},  {2, 0, 0, 0, 1.0},  {2, 1, 0, 1, 1.0},  {2, 2, 0, 2, 1.0},  {2, 3, 0, 3, 1.0},  {2, 4, 0, 4, 1.0},
  {2, 5, 0, 5, 1.0},  {2, 6, 0, 6, 1.0},  {2, 7, 0, 7, 1.0},  {2, 8, 0, 0, -1.0},  {2, 8, 1, 1, 1.0},  {2, 9, 1, 2, 1.0},
  {2, 10, 1, 3, 1.0},  {2, 11, 1, 4, 1.0},  {2, 12, 1, 5, 1.0},  {2, 13, 1, 6, 1.0},  {2, 14, 1, 7, 1.0},  {2, 15, 0, 0, -1.0},
  {2, 15, 2, 2, 1.0},  {2, 16, 2, 3, 1.0},  {2, 17, 2, 4, 1.0},  {2, 18, 2, 5, 1.0},  {2, 19, 2, 6, 1.0},  {2, 20, 2, 7, 1.0},
  {2, 21, 0, 0, -1.0},  {2, 21, 3, 3, 1.0},  {2, 22, 3, 4, 1.0},  {2, 23, 3, 5, 1.0},  {2, 24, 3, 6, 1.0},  {2, 25, 3, 7, 1.0},
  {2, 26, 0, 0, -1.0},  {2, 26, 4, 4, 1.0},  {2, 27, 4, 5, 1.0},  {2, 28, 4, 6, 1.0},  {2, 29, 4, 7, 1.0},  {2, 30, 5, 5, 1.0},
  {2, 31, 5, 6, 1.0},  {2, 32, 5, 7, 1.0},  {2, 33, 6, 6, 1.0},  {2, 34, 6, 7, 1.0},  {2, 35, 7, 7, 1.0},  {2, 36, 0, 1, -1.0},
  {2, 37, 0, 2, -1.0},  {2, 38, 0, 3, -1.0},  {2, 39, 0, 4, -1.0},  {2, 40, 0, 5, -1.0},  {2, 41, 0, 6, -1.0},  {2, 42, 0, 7, -1.0},
  {2, 43, 0, 1, -1.0},  {2, 49, 0, 1, -1.0},  {2, 54, 0, 1, -1.0},  {2, 64, 0, 2, -1.0},  {2, 65, 0, 3, -1.0},  {2, 66, 0, 4, -1.0},
  {2, 67, 0, 5, -1.0},  {2, 68, 0, 6, -1.0},  {2, 69, 0, 7, -1.0},  {2, 70, 0, 2, -1.0},  {2, 75, 0, 2, -1.0},  {2, 85, 0, 3, -1.0},
  {2, 86, 0, 4, -1.0},  {2, 87, 0, 5, -1.0},  {2, 88, 0, 6, -1.0},  {2, 89, 0, 7, -1.0},  {2, 90, 0, 3, -1.0},  {2, 100, 0, 4, -1.0},
  {2, 101, 0, 5, -1.0},  {2, 102, 0, 6, -1.0},  {2, 103, 0, 7, -1.0},  {2, 120, 1, 1, -1.0},  {2, 121, 1, 2, -1.0},  {2, 122, 1, 3, -1.0},
  {2, 123, 1, 4, -1.0},  {2, 124, 1, 5, -1.0},  {2, 125, 1, 6, -1.0},  {2, 126, 1, 7, -1.0},  {2, 127, 1, 1, -1.0},  {2, 127, 2, 2, -1.0},
  {2, 128, 2, 3, -1.0},  {2, 129, 2, 4, -1.0},  {2, 130, 2, 5, -1.0},  {2, 131, 2, 6, -1.0},  {2, 132, 2, 7, -1.0},  {2, 133, 1, 1, -1.0},
  {2, 133, 3, 3, -1.0},  {2, 134, 3, 4, -1.0},  {2, 135, 3, 5, -1.0},  {2, 136, 3, 6, -1.0},  {2, 137, 3, 7, -1.0},  {2, 138, 1, 1, -1.0},
  {2, 138, 4, 4, -1.0},  {2, 139, 4, 5, -1.0},  {2, 140, 4, 6, -1.0},  {2, 141, 4, 7, -1.0},  {2, 142, 5, 5, -1.0},  {2, 143, 5, 6, -1.0},
  {2, 144, 5, 7, -1.0},  {2, 145, 6, 6, -1.0},  {2, 146, 6, 7, -1.0},  {2, 147, 7, 7, -1.0},  {2, 148, 1, 2, -1.0},  {2, 149, 1, 3, -1.0},
  {2, 150, 1, 4, -1.0},  {2, 151, 1, 5, -1.0},  {2, 152, 1, 6, -1.0},  {2, 153, 1, 7, -1.0},  {2, 154, 1, 2, -1.0},  {2, 159, 1, 2, -1.0},
  {2, 169, 1, 3, -1.0},  {2, 170, 1, 4, -1.0},  {2, 171, 1, 5, -1.0},  {2, 172, 1, 6, -1.0},  {2, 173, 1, 7, -1.0},  {2, 174, 1, 3, -1.0},
  {2, 184, 1, 4, -1.0},  {2, 185, 1, 5, -1.0},  {2, 186, 1, 6, -1.0},  {2, 187, 1, 7, -1.0},  {2, 204, 2, 2, -1.0},  {2, 205, 2, 3, -1.0},
  {2, 206, 2, 4, -1.0},  {2, 207, 2, 5, -1.0},  {2, 208, 2, 6, -1.0},  {2, 209, 2, 7, -1.0},  {2, 210, 2, 2, -1.0},  {2, 210, 3, 3, -1.0},
  {2, 211, 3, 4, -1.0},  {2, 212, 3, 5, -1.0},  {2, 213, 3, 6, -1.0},  {2, 214, 3, 7, -1.0},  {2, 215, 2, 2, -1.0},  {2, 215, 4, 4, -1.0},
  {2, 216, 4, 5, -1.0},  {2, 217, 4, 6, -1.0},  {2, 218, 4, 7, -1.0},  {2, 219, 5, 5, -1.0},  {2, 220, 5, 6, -1.0},  {2, 221, 5, 7, -1.0},
  {2, 222, 6, 6, -1.0},  {2, 223, 6, 7, -1.0},  {2, 224, 7, 7, -1.0},  {2, 225, 2, 3, -1.0},  {2, 226, 2, 4, -1.0},  {2, 227, 2, 5, -1.0},
  {2, 228, 2, 6, -1.0},  {2, 229, 2, 7, -1.0},  {2, 230, 2, 3, -1.0},  {2, 240, 2, 4, -1.0},  {2, 241, 2, 5, -1.0},  {2, 242, 2, 6, -1.0},
  {2, 243, 2, 7, -1.0},  {2, 260, 3, 3, -1.0},  {2, 261, 3, 4, -1.0},  {2, 262, 3, 5, -1.0},  {2, 263, 3, 6, -1.0},  {2, 264, 3, 7, -1.0},
  {2, 265, 3, 3, -1.0},  {2, 265, 4, 4, -1.0},  {2, 266, 4, 5, -1.0},  {2, 267, 4, 6, -1.0},  {2, 268, 4, 7, -1.0},  {2, 269, 5, 5, -1.0},
  {2, 270, 5, 6, -1.0},  {2, 271, 5, 7, -1.0},  {2, 272, 6, 6, -1.0},  {2, 273, 6, 7, -1.0},  {2, 274, 7, 7, -1.0},  {2, 275, 3, 4, -1.0},
  {2, 276, 3, 5, -1.0},  {2, 277, 3, 6, -1.0},  {2, 278, 3, 7, -1.0},  {2, 295, 4, 4, -1.0},  {2, 296, 4, 5, -1.0},  {2, 297, 4, 6, -1.0},
  {2, 298, 4, 7, -1.0},  {2, 299, 5, 5, -1.0},  {2, 300, 5, 6, -1.0},  {2, 301, 5, 7, -1.0},  {2, 302, 6, 6, -1.0},  {2, 303, 6, 7, -1.0},
  {2, 304, 7, 7, -1.0},  {3, 1, 0, 0, 1.0},  {3, 8, 0, 1, 1.0},  {3, 9, 0, 2, 1.0},  {3, 10, 0, 3, 1.0},  {3, 11, 0, 4, 1.0},
  {3, 12, 0, 5, 1.0},  {3, 13, 0, 6, 1.0},  {3, 14, 0, 7, 1.0},  {3, 36, 1, 1, 1.0},  {3, 37, 1, 2, 1.0},  {3, 38, 1, 3, 1.0},
  {3, 39, 1, 4, 1.0},  {3, 40, 1, 5, 1.0},  {3, 41, 1, 6, 1.0},  {3, 42, 1, 7, 1.0},  {3, 43, 2, 2, 1.0},  {3, 44, 2, 3, 1.0},
  {3, 45, 2, 4, 1.0},  {3, 46, 2, 5, 1.0},  {3, 47, 2, 6, 1.0},  {3, 48, 2, 7, 1.0},  {3, 49, 3, 3, 1.0},  {3, 50, 3, 4, 1.0},
  {3, 51, 3, 5, 1.0},  {3, 52, 3, 6, 1.0},  {3, 53, 3, 7, 1.0},  {3, 54, 4, 4, 1.0},  {3, 55, 4, 5, 1.0},  {3, 56, 4, 6, 1.0},
  {3, 57, 4, 7, 1.0},  {3, 58, 5, 5, 1.0},  {3, 59, 5, 6, 1.0},  {3, 60, 5, 7, 1.0},  {3, 61, 6, 6, 1.0},  {3, 62, 6, 7, 1.0},
  {3, 63, 7, 7, 1.0},  {4, 0, 0, 0, 0.0},  {4, 1, 0, 1, 0.0},  {4, 2, 0, 2, 0.0},  {4, 3, 0, 3, 0.0},  {4, 4, 0, 4, 0.0},
  {4, 5, 0, 5, 0.0},  {4, 6, 0, 6, 0.0},  {4, 7, 0, 7, 0.0},  {4, 8, 1, 1, 0.0},  {4, 9, 1, 2, 0.0},  {4, 10, 1, 3, 0.0},
  {4, 11, 1, 4, 0.0},  {4, 12, 1, 5, 0.0},  {4, 13, 1, 6, 0.0},  {4, 14, 1, 7, 0.0},  {4, 15, 2, 2, 0.0},  {4, 16, 2, 3, 0.0},
  {4, 17, 2, 4, 0.0},  {4, 18, 2, 5, 0.0},  {4, 19, 2, 6, 0.0},  {4, 20, 2, 7, 0.0},  {4, 21, 3, 3, 0.0},  {4, 22, 3, 4, 0.0},
  {4, 23, 3, 5, 0.0},  {4, 24, 3, 6, 0.0},  {4, 25, 3, 7, 0.0},  {4, 26, 4, 4, 0.0},  {4, 27, 4, 5, 0.0},  {4, 28, 4, 6, 0.0},
  {4, 29, 4, 7, 0.0},  {4, 30, 0, 0, -1.0},  {4, 30, 5, 5, 0.0},  {4, 31, 5, 6, 0.0},  {4, 32, 5, 7, 0.0},  {4, 33, 0, 0, -1.0},
  {4, 33, 6, 6, 0.0},  {4, 34, 6, 7, 0.0},  {4, 35, 0, 0, -1.0},  {4, 35, 7, 7, 0.0},  {4, 58, 0, 1, -1.0},  {4, 61, 0, 1, -1.0},
  {4, 63, 0, 1, -1.0},  {4, 79, 0, 2, -1.0},  {4, 82, 0, 2, -1.0},  {4, 84, 0, 2, -1.0},  {4, 94, 0, 3, -1.0},  {4, 97, 0, 3, -1.0},
  {4, 99, 0, 3, -1.0},  {4, 104, 0, 4, -1.0},  {4, 107, 0, 4, -1.0},  {4, 109, 0, 4, -1.0},  {4, 110, 0, 5, -1.0},  {4, 111, 0, 6, -1.0},
  {4, 112, 0, 7, -1.0},  {4, 113, 0, 5, -1.0},  {4, 115, 0, 5, -1.0},  {4, 116, 0, 6, -1.0},  {4, 117, 0, 7, -1.0},  {4, 118, 0, 6, -1.0},
  {4, 119, 0, 7, -1.0},  {4, 142, 1, 1, -1.0},  {4, 145, 1, 1, -1.0},  {4, 147, 1, 1, -1.0},  {4, 163, 1, 2, -1.0},  {4, 166, 1, 2, -1.0},
  {4, 168, 1, 2, -1.0},  {4, 178, 1, 3, -1.0},  {4, 181, 1, 3, -1.0},  {4, 183, 1, 3, -1.0},  {4, 188, 1, 4, -1.0},  {4, 191, 1, 4, -1.0},
  {4, 193, 1, 4, -1.0},  {4, 194, 1, 5, -1.0},  {4, 195, 1, 6, -1.0},  {4, 196, 1, 7, -1.0},  {4, 197, 1, 5, -1.0},  {4, 199, 1, 5, -1.0},
  {4, 200, 1, 6, -1.0},  {4, 201, 1, 7, -1.0},  {4, 202, 1, 6, -1.0},  {4, 203, 1, 7, -1.0},  {4, 219, 2, 2, -1.0},  {4, 222, 2, 2, -1.0},
  {4, 224, 2, 2, -1.0},  {4, 234, 2, 3, -1.0},  {4, 237, 2, 3, -1.0},  {4, 239, 2, 3, -1.0},  {4, 244, 2, 4, -1.0},  {4, 247, 2, 4, -1.0},
  {4, 249, 2, 4, -1.0},  {4, 250, 2, 5, -1.0},  {4, 251, 2, 6, -1.0},  {4, 252, 2, 7, -1.0},  {4, 253, 2, 5, -1.0},  {4, 255, 2, 5, -1.0},
  {4, 256, 2, 6, -1.0},  {4, 257, 2, 7, -1.0},  {4, 258, 2, 6, -1.0},  {4, 259, 2, 7, -1.0},  {4, 269, 3, 3, -1.0},  {4, 272, 3, 3, -1.0},
  {4, 274, 3, 3, -1.0},  {4, 279, 3, 4, -1.0},  {4, 282, 3, 4, -1.0},  {4, 284, 3, 4, -1.0},  {4, 285, 3, 5, -1.0},  {4, 286, 3, 6, -1.0},
  {4, 287, 3, 7, -1.0},  {4, 288, 3, 5, -1.0},  {4, 290, 3, 5, -1.0},  {4, 291, 3, 6, -1.0},  {4, 292, 3, 7, -1.0},  {4, 293, 3, 6, -1.0},
  {4, 294, 3, 7, -1.0},  {4, 299, 4, 4, -1.0},  {4, 302, 4, 4, -1.0},  {4, 304, 4, 4, -1.0},  {4, 305, 4, 5, -1.0},  {4, 306, 4, 6, -1.0},
  {4, 307, 4, 7, -1.0},  {4, 308, 4, 5, -1.0},  {4, 310, 4, 5, -1.0},  {4, 311, 4, 6, -1.0},  {4, 312, 4, 7, -1.0},  {4, 313, 4, 6, -1.0},
  {4, 314, 4, 7, -1.0},  {4, 315, 5, 5, -1.0},  {4, 316, 5, 6, -1.0},  {4, 317, 5, 7, -1.0},  {4, 318, 5, 5, -1.0},  {4, 318, 6, 6, -1.0},
  {4, 319, 6, 7, -1.0},  {4, 320, 5, 5, -1.0},  {4, 320, 7, 7, -1.0},  {4, 321, 5, 6, -1.0},  {4, 322, 5, 7, -1.0},  {4, 323, 5, 6, -1.0},
  {4, 324, 5, 7, -1.0},  {4, 325, 6, 6, -1.0},  {4, 326, 6, 7, -1.0},  {4, 327, 6, 6, -1.0},  {4, 327, 7, 7, -1.0},  {4, 328, 6, 7, -1.0},
  {4, 329, 7, 7, -1.0}
};
const HecProblem::conVar HecProblem::con_vars[] = {
  {4, 0, 0},  {4, 1, 0},  {4, 2, 0},  {4, 3, 0},  {4, 4, 0},
  {4, 5, 0},  {4, 6, 0},  {4, 7, 0},  {4, 8, 0},  {4, 9, 0},  {4, 10, 0},
  {4, 11, 0},  {4, 12, 0},  {4, 13, 0},  {4, 14, 0},  {4, 15, 0},  {4, 16, 0},
  {4, 17, 0},  {4, 18, 0},  {4, 19, 0},  {4, 20, 0},  {4, 21, 0},  {4, 22, 0},
  {4, 23, 0},  {4, 24, 0},  {4, 25, 0},  {4, 26, 0},  {4, 27, 0},  {4, 28, 0},
  {4, 29, 0},  {4, 30, 1},  {4, 31, 0},  {4, 32, 0},  {4, 33, 1},  {4, 34, 0},
  {4, 35, 1}
};
