/* 
   This file was automatically generated on February 23, 2015 23:51:59
   by GpoSolver, (c) 2013--2014, Jan Heller, hellej1@cmp.felk.cvut.cz,
   Czech Technical University, Prague, Czech Republic 

   This solver takes:
       4 residual parameters: [b1, b2, b3, b4]
       4 problem parameters : [a1, a2, a3, a4]
*/

#include "pop_problem.h"

using namespace GpoSolver;
using namespace Eigen;


void PopProblem::updateAuxiliaries(const double *pars, double *aux) const {
  double t2 = pars[2]*pars[2];
  double t3 = pars[3]*pars[3];
  aux[0] = t2;
  aux[1] = t3;
  aux[2] = -t2;
  aux[3] = -t3;
}

double PopProblem::evalPolyObjective(const double *rpars, const double *ppars, const double *vars) const {
  double t3 = vars[0]*vars[0];
  double t2 = rpars[1]+rpars[0]*vars[1]-(ppars[0]*ppars[0])*t3;
  double t4 = rpars[3]+rpars[2]*vars[1]-(ppars[1]*ppars[1])*t3;
  double t0 = t2*t2+t4*t4;

  return t0;
}

void PopProblem::evalPolyConstraints(const double *vars, const double *pars, double *cons) const {

  double aux[5];

  updateAuxiliaries(pars, aux);

  double t2 = vars[0]*vars[0];
  double t3 = vars[1]*vars[1];
  cons[0] = aux[0]*t2+aux[1]*t3-1.0;
  cons[1] = aux[2]*t2+aux[3]*t3+1.0;
}

void PopProblem::evalSdpObjectiveVariables(const double *rpars, const double *ppars, double **vars) const {
  double t2 = ppars[0]*ppars[0];
  double t3 = ppars[1]*ppars[1];
  *(vars[0]) = rpars[1]*rpars[1]+rpars[3]*rpars[3];
  *(vars[1]) = rpars[0]*rpars[1]*2.0+rpars[2]*rpars[3]*2.0;
  *(vars[2]) = rpars[1]*t2*-2.0-rpars[3]*t3*2.0;
  *(vars[3]) = rpars[0]*rpars[0]+rpars[2]*rpars[2];
  *(vars[4]) = rpars[0]*t2*-2.0-rpars[2]*t3*2.0;
  *(vars[5]) = t2*t2+t3*t3;
}

void PopProblem::evalSdpConstraintsVariables(const double *pars, const double *vmul, double **vars) const {

  double aux[5];

  updateAuxiliaries(pars, aux);

  *(vars[0]) = vmul[0] * (aux[0]);  *(vars[1]) = vmul[1] * (aux[1]);  *(vars[2]) = vmul[2] * (aux[0]);  *(vars[3]) = vmul[3] * (aux[0]);
  *(vars[4]) = vmul[4] * (aux[1]);  *(vars[5]) = vmul[5] * (aux[1]);  *(vars[6]) = vmul[6] * (aux[0]);  *(vars[7]) = vmul[7] * (aux[0]);
  *(vars[8]) = vmul[8] * (aux[1]);  *(vars[9]) = vmul[9] * (aux[0]);  *(vars[10]) = vmul[10] * (aux[1]);  *(vars[11]) = vmul[11] * (aux[1]);
  *(vars[12]) = vmul[12] * (aux[2]);  *(vars[13]) = vmul[13] * (aux[3]);  *(vars[14]) = vmul[14] * (aux[2]);  *(vars[15]) = vmul[15] * (aux[2]);
  *(vars[16]) = vmul[16] * (aux[3]);  *(vars[17]) = vmul[17] * (aux[3]);  *(vars[18]) = vmul[18] * (aux[2]);  *(vars[19]) = vmul[19] * (aux[2]);
  *(vars[20]) = vmul[20] * (aux[3]);  *(vars[21]) = vmul[21] * (aux[2]);  *(vars[22]) = vmul[22] * (aux[3]);  *(vars[23]) = vmul[23] * (aux[3]);
}

const int PopProblem::num_blocks = 3;
const int PopProblem::num_cons = 14;
const int PopProblem::num_pcons = 2;
const int PopProblem::num_pvars = 2;
const int PopProblem::num_rpars = 4;
const int PopProblem::num_ppars = 4;
const int PopProblem::problem_size = 12;
const int PopProblem::relax_order = 2;
const int PopProblem::max_degree = 4;
const int PopProblem::rank_shift = 1;
const int PopProblem::block_sizes[] = {6, 3, 3};

const int PopProblem::num_obj_data = 6;
const int PopProblem::num_obj_vars = 6;
const PopProblem::objData  PopProblem::obj_data[] = {
  {0, 0.0},  {2, 0.0},  {3, 0.0},  {5, 0.0},  {7, 0.0},  {10, 0.0}
};
const PopProblem::objVar PopProblem::obj_vars[] = {
  {0},  {2},  {3},  {5},  {7},  {10}
};

const int PopProblem::num_con_data = 57;
const int PopProblem::num_con_vars = 24;
const PopProblem::conData PopProblem::con_data[] = {
  {0, 0, 0, 0, 1.0},  {0, 1, 0, 1, 1.0},  {0, 2, 0, 2, 1.0},  {0, 3, 0, 3, 1.0},  {0, 3, 1, 1, 1.0},
  {0, 4, 0, 4, 1.0},  {0, 4, 1, 2, 1.0},  {0, 5, 0, 5, 1.0},  {0, 5, 2, 2, 1.0},  {0, 6, 1, 3, 1.0},  {0, 7, 1, 4, 1.0},
  {0, 7, 2, 3, 1.0},  {0, 8, 1, 5, 1.0},  {0, 8, 2, 4, 1.0},  {0, 9, 2, 5, 1.0},  {0, 10, 3, 3, 1.0},  {0, 11, 3, 4, 1.0},
  {0, 12, 3, 5, 1.0},  {0, 12, 4, 4, 1.0},  {0, 13, 4, 5, 1.0},  {0, 14, 5, 5, 1.0},  {1, 0, 0, 0, -1.0},  {1, 1, 0, 1, -1.0},
  {1, 2, 0, 2, -1.0},  {1, 3, 0, 0, 0.0},  {1, 3, 1, 1, -1.0},  {1, 4, 1, 2, -1.0},  {1, 5, 0, 0, 0.0},  {1, 5, 2, 2, -1.0},
  {1, 6, 0, 1, 0.0},  {1, 7, 0, 2, 0.0},  {1, 8, 0, 1, 0.0},  {1, 9, 0, 2, 0.0},  {1, 10, 1, 1, 0.0},  {1, 11, 1, 2, 0.0},
  {1, 12, 1, 1, 0.0},  {1, 12, 2, 2, 0.0},  {1, 13, 1, 2, 0.0},  {1, 14, 2, 2, 0.0},  {2, 0, 0, 0, 1.0},  {2, 1, 0, 1, 1.0},
  {2, 2, 0, 2, 1.0},  {2, 3, 0, 0, 0.0},  {2, 3, 1, 1, 1.0},  {2, 4, 1, 2, 1.0},  {2, 5, 0, 0, 0.0},  {2, 5, 2, 2, 1.0},
  {2, 6, 0, 1, 0.0},  {2, 7, 0, 2, 0.0},  {2, 8, 0, 1, 0.0},  {2, 9, 0, 2, 0.0},  {2, 10, 1, 1, 0.0},  {2, 11, 1, 2, 0.0},
  {2, 12, 1, 1, 0.0},  {2, 12, 2, 2, 0.0},  {2, 13, 1, 2, 0.0},  {2, 14, 2, 2, 0.0}
};
const PopProblem::conVar PopProblem::con_vars[] = {
  {1, 3, 0},  {1, 5, 0},  {1, 6, 0},  {1, 7, 0},  {1, 8, 0},
  {1, 9, 0},  {1, 10, 0},  {1, 11, 0},  {1, 12, 0},  {1, 12, 1},  {1, 13, 0},
  {1, 14, 0},  {2, 3, 0},  {2, 5, 0},  {2, 6, 0},  {2, 7, 0},  {2, 8, 0},
  {2, 9, 0},  {2, 10, 0},  {2, 11, 0},  {2, 12, 0},  {2, 12, 1},  {2, 13, 0},
  {2, 14, 0}
};
